% f05_armax_show
% ukzka ARMAX proces

close all
clear all
clc

% delka rady
n=200;

% priprava bileho sumu (stedni hodnota je vzdy 0)
wn_var = 1 ; % rozptyl bileho sumu, pro 1 vyjde N(0,1)
e=randn(n,1)*sqrt(wn_var);

% ukazkove zvolime tento druh procesu
% y_t = 1.5 + 0.3*y_{t-1}+ \epsilon_t + 0.7*\epsilon_{t-1}- 0.3*\epsilon_{t-2}, ARMAX(1,2) proces

% simulace cyklem
y(1)=1.5 + e(1);
y(2,1)=1.5 + 0.3*y(1)+e(2)+0.7*e(1);
for k=3:n
    y(k,1)=1.5 + 0.3*y(k-1,1)+e(k)+0.7*e(k-1)-0.3*e(k-2);
end

% simulace pomoci funkci
A=[1 -0.3]; B=[1.5]; C=[1 0.7 -0.3];
th_s=idpoly(A,B,C);
u = ones(size(e));
ue = [u e]; %slome vstup (u, jedniky) a um (e) vedle sebe, funkce "sim" je poaduje jako jeden argument
yp=sim(th_s,ue);

% stredni hodnota a prumer
mu = 1.5 / (1 -0.3); % stredni hodnota procesu
me = mean (y); % prumer = odhad stredni hodnoty procesu

% srovnani - oboji je stejne
figure
plot(y)
hold on
plot(yp,'r--')
plot(mu*ones(size(y)),'k')
plot(me*ones(size(y)),'g')
legend('y simulovane cyklem','y simulovane funkcemi','stedni hodnota procesu','prumer')
title('Srovnani zpusobu simulaci')

figure
subplot(2,1,1)
plotacf(y,39)
title('Autokorelacni funkce; puvodni pozorovana rada')
subplot(2,1,2)
plotpacf(y,39)
title('Parcialni autokor. fce; puvodni pozorovana rada')