% f06_arima_show
% Ukzky ARIMA proces

close all
clear all
clc


% \Delta y_t = 0.5 + 0.3*\Deltay_{t-1}+ \epsilon_t + 0.7*\epsilon_{t-1}- 0.3*\epsilon_{t-2}, ARIMA(1,1,2) proces

% delka rady
n=200;

% priprava bileho sumu (stedni hodnota je vzdy 0)
wn_var = 1 ; % rozptyl bileho sumu, pro 1 vyjde N(0,1)
e=randn(n,1)*sqrt(wn_var);


% simulace cyklem
yd(1)=0.5 + e(1);
yd(2,1)=0.5 + 0.3*yd(1)+e(2)+0.7*e(1);
for k=3:n
    yd(k,1)=0.5 + 0.3*yd(k-1,1)+e(k)+0.7*e(k-1)-0.3*e(k-2);
end

% simulace pomoci funkci
A=[1 -0.3]; B=[0.5]; C=[1 0.7 -0.3];
th=idpoly(A,B,C);
u = ones(size(e));
ue = [u e]; %slome vstup (u, jedniky) a um (e) vedle sebe, funkce "sim" je poaduje jako jeden argument
ydp=sim(th,ue);

% srovnani - oboji je stejne
figure
plot(yd)
title('\Delta y_t = 0.5 + 0.3*\Deltay_{t-1}+\epsilon_t + 0.7*\epsilon_{t-1}- 0.3*\epsilon_{t-2}, ARIMA(1,1,2) proces')
hold on
plot(ydp,'r--')


y=[0;cumsum(yd)+0];  % jedna z moznosti jak ze stacionarni rady udelat nestacionarni
w=[diff(y)]; %yd(1);

plot(w,'g-.')
legend('Simulace cyklem','Simulace funkcemi','Diferencovana integrovana rada')


figure
plot(y)
title('nestacionarni rada')


figure
subplot(2,1,1)
plotacf(y,39)
title('Autokorelacni funkce; puvodni pozorovana rada')
subplot(2,1,2)
plotpacf(y,39)
title('Parcialni autokor. fce; puvodni pozorovana rada')


figure
subplot(2,1,1)
plotacf(w,39)
title('Autokorelacni funkce; \Delta y_t = 0.5 + 0.3*\Deltay_{t-1}+\epsilon_t + 0.7*\epsilon_{t-1}- 0.3*\epsilon_{t-2}, ARIMA(1,1,2) proces')
subplot(2,1,2)
plotpacf(w,39)
title('Parcialni autokor. fce; \Delta y_t = 0.5 + 0.3*\Deltay_{t-1}+\epsilon_t + 0.7*\epsilon_{t-1}- 0.3*\epsilon_{t-2}, ARIMA(1,1,2) proces')

