%---------------------------------------------------
% f08_ma
% Procesy MA -- identifikace
%---------------------------------------------------

close all
clear all
clc

y=[-0.5078
    0.3349
   -0.4348
   -1.2750
   -0.6713
    0.3616
    0.4330
    0.4947
    1.9337
    2.0291
    2.4964
    3.5915
   -0.3487
   -1.5317
   -0.3754
    1.4787
    1.5592
    1.9951
    1.3301
   -0.4671
   -0.7349
   -0.4140
   -0.6482
   -0.5700
   -0.1883
   -1.0589
    0.5326
    0.9073
   -0.0950
   -0.5004
   -0.4129
    0.0769
    0.7948
    0.3016
   -0.3761
   -0.8133
   -0.8314
    0.2789
    1.3837
    1.7855
   -0.0419
   -1.7992
    0.5792
    0.6931
    1.2368
    1.3187
    1.4421
    0.8347
   -0.4603
   -3.8781
   -2.4331
   -0.4159
   -1.4234
   -1.2698
   -0.8352
    0.1741
    0.1421
    2.1747
    1.9313
   -0.2150
   -0.9877
    0.2394
    0.3459
    0.7693
    1.0799
   -0.4968
   -0.0079
    0.8094
   -0.8734
   -0.6664
   -0.1331
   -3.0121
   -2.0579
    0.6566
   -1.2605
   -0.9017
   -0.3189
   -0.6933
   -1.8855
   -0.5871
    0.7306
    1.3778
    0.1776
    0.6423
    0.9109
    0.0057
    0.7479
    1.0790
    0.1474
   -2.4532
    0.4529
    1.7535
    1.1781
   -0.1257
   -0.6958
    0.8018
    1.9593
    0.8484
    1.0463
    2.0096
    1.7600
    1.3186
   -1.2060
    0.5697
   -0.0112
   -0.2306
   -0.2909
   -0.2609
   -1.7324
   -1.7809
   -0.5524
    0.7377
    1.5890
   -0.2498
   -0.2637
    1.1376
    0.4305
    0.6446
   -0.6575
   -1.0544
    0.8932
   -1.3637
   -1.3758
   -0.1368
   -1.9548
    0.0022
    0.7239
    0.9982
    0.1908
    0.8038
    0.4768
   -1.0315
   -1.4083
    0.4332
    1.0892
    0.4322
    0.0364
   -0.1958
   -0.7278
    1.0743
    1.3795
   -1.0352
   -2.2640
    0.1434
    0.5258
   -0.3374
    0.3458
   -1.6151
   -1.1561
    0.5160
];
 
%---------------------------------------------------
% Obrazek casove rady
%---------------------------------------------------
figure
plot(y)
hold on
plot(mean(y)*ones(size(y)),'g')
plot(zeros(size(y)),'k:')
title('Pozorovana rada')
legend('data','prumer','zero line')
% zjistujeme zda ma proces nenulovou stredni hodnotu, v tom pripade bychom
% proces modelovali jako MA input eXtended 

%---------------------------------------------------
% Autokor. a parc. autokor. fce
%---------------------------------------------------
figure
subplot(2,1,1)
plotacf(y,29)
title('Autokorelacni funkce')
subplot(2,1,2)
plotpacf(y,29)
title('Parcialni autokor. fce')

% Funkce PACF klesa systematicky (oscilaci) do Quenouilleova intervalu. Autokorelacni funkce je stat. vyznamna jen pro jedno zpozdeni. Patrne se tedy bude jednat o
% MA(1).

%---------------------------------------------------
% Odhad
%---------------------------------------------------
% Odhad parametru modelu pomoci funkce ARMAX -- viz help a documentation
% MA(1) = ARMA(0,1), tedy funkci ARMAX zadame krome dat "y" jeste matici s
% rady procesu [0 1]
th=armax(y,[0 1]); % MA1

%---------------------------------------------------
% Zobrazeni vysledku
%---------------------------------------------------
% funkce PRESENT zobrazi vysledky odhadu parametru modelu, smerodatne
% odchylky parametru modelu, ztratovou funkci a Akaikeho kriterium FPE
% (final prediction error).
% Vzdy budeme volit model s parametry statisticky vyznamnymi - to bude
% jakasi pripustna mnozina modelu, vybereme ten s minimalni chybou (FPE).
%
% Vyznamnost parametru otestujeme pomoci t-testu. Podil absolutni hodnoty
% parametru a jeho smerodatne odchylky ma byt vetsi nez prislusny Studentuv
% kvantil, coz je pro velka n zhruba 2. 
% Staci tedy zjistit, je-li parametr vic nez 2x tak velky jako jeho std.

%---------------------------------------------------
% Jine modely
%---------------------------------------------------
% pro jistotu si odhadneme jine, blizke procesy abychom nasli nejnizsi FPE
th2=armax(y,[0 2]); % MA2
present(th2) % parametr u druheho zpozdeni je statisticky nevyznamny
th3=armax(y,[1 1]); % ARMA11
present(th3) % parametr AR casti je statisticky nevyznamny
th4=armax(y,[1 0]); % AR1
present(th4) % FPE je vyssi nez u MA1
% => ukazuje se ze nejlepsi je opravdu MA1 (pokud by ovsem nevysla
% verifikace, tak bychom museli zvolit jiny proces (s vyssim FPE)

pars = th.ParameterVector; % vytazeni vektoru parametru z "th"

%---------------------------------------------------
% Verifikace - predvyrobene funkce (nutno zkopirovat k sobe)
%---------------------------------------------------
% a) verifikace parametru
p_sig = par_sig(th) % help par_sig pro vice info
% b) verifikace rezidui
[sig,tests,sk]=res_sig(th,y) %help res_sig pro vice info
% jeden z testu normality nevysel!

%---------------------------------------------------
% Stabilita
%---------------------------------------------------
% Stabilitu otestujeme pomoci funkce PZMAP, ktera pocita/kresli nuly a poly
% systemu, chceme je vsechny uvnitr jednotkove kruznice
figure
pzmap(th)


%---------------------------------------------------
% Predikce
%---------------------------------------------------
% na vypocet predikci slouzi funkce PREDICT, pro predikci modelu v theta
% formatu a pro dana data na K kroku dopredu pouzivame prikaz:
% YP = PREDICT(MODEL,DATA,K)

% K je predikcni horizont, k predikci hodnoty na "K" obdobi dopredu se
% pouziji veskera data dostupna do casu "t-K".

% Vidime, jak se predikce na vice kroku dopredu meni - cim dal tim min se
% podobaji skutecnym hodnotam. Na rozdil od MA procesu ale predikce
% konverguji k nule postupne -- modely maji "dlouhou" pamet.

% Jednokrokove predikce modelu
figure
yp1=predict(th,y,1);
plot(y,'b')
hold on
plot(yp1,'r');
title('Predpoved na 1 krok dopredu')
hold off

% Dvoukrokove predikce modelu
% MA(1) uz predpovida svoji stredni hodnotu, tj. nulu - rikame, ze MA
% procesy maji "kratkou" pamet.
figure
yp2=predict(th,y,2);
plot(y,'b')
hold on
plot(yp2,'r');
title('Predpoved na 2 kroky dopredu')
hold off

% Trikrokove predikce modelu
% MA(2) uz predpovida svoji stredni hodnotu, tj. nulu
figure
yp3=predict(th,y,3);
plot(y,'b')
hold on
plot(yp3,'r');
title('Predpoved na 3 kroky dopredu')
hold off

%---------------------------------------------------
% Predpoved do budoucna
%---------------------------------------------------
h_p  = 15 ; % horizont predikce
e=pe(y,th); % rezidua

y_p(1) = pars*e(end);
for i=2:h_p % jen pro MA1
    y_p(i)=0;
end

% kresleni predpovedi
figure
plot(y)
hold on
plot(length(y)+1:length(y)+1+length(y_p)-1,y_p,'r.')

%---------------------------------------------------
% konfidencni intervaly predpovedi
%---------------------------------------------------
s2e = var(e); % odhad rozptylu nhodn sloky
s2et(1) = s2e;
for i=2:h_p % takhle to plat jen pro MA1 proces
    s2et(i) = (1 + pars)*s2e;
end

tt = tinv(1-.05/2,length(y));
y_ph = y_p + tt*sqrt(s2et);
y_pd = y_p - tt*sqrt(s2et);

plot(length(y)+1:length(y)+1+length(y_p)-1,y_ph,'g')
plot(length(y)+1:length(y)+1+length(y_p)-1,y_pd,'g')
title('Predpoved do budoucna a konfidencni intervaly predpovedi')
