%---------------------------------------------------
% f09_arma
% Procesy ARMA - identifikace
%---------------------------------------------------

close all
clear all
clc

y=[
    0.9834
    3.5322
    6.1923
    7.7695
    8.1399
    7.6897
    5.4836
    3.1673
    2.4531
    2.4173
    1.3729
   -0.3364
   -0.3427
   -0.9946
   -2.7403
   -2.8932
   -0.8250
   -0.4133
   -0.6934
   -0.8587
   -1.8042
   -2.5082
   -1.5403
    0.6054
   -0.7878
   -2.9647
   -2.4395
   -3.2538
   -4.5358
   -4.6938
   -4.1136
   -4.1288
   -4.4199
   -4.4277
   -5.8682
   -6.9382
   -7.0481
   -7.0469
   -6.9058
   -8.0749
   -7.6029
   -4.5336
   -3.0149
   -3.5644
   -3.6577
   -3.5001
   -3.4457
   -4.8006
   -4.2160
   -1.9489
   -0.7434
    1.5739
    0.7906
   -1.8904
   -2.1944
   -1.2886
   -1.2378
   -1.3136
   -2.1404
   -3.2200
   -3.3704
   -2.3479
   -1.7853
   -2.9878
   -4.3926
   -4.4779
   -4.5251
   -3.1403
   -0.8089
    0.1095
    0.2357
    0.3917
    1.9804
    0.7539
   -0.0427
    0.7468
    0.3340
    1.1875
    2.4474
    1.1126
   -1.9551
   -2.5393
   -2.6797
   -4.8625
   -6.2035
   -6.3040
   -7.1928
   -8.6285
   -8.4739
   -9.2751
   -8.7520
   -6.0282
   -5.1017
   -4.8622
   -5.3047
   -6.6350
   -6.5373
   -4.6459
   -2.0914
   -0.8600
   -0.2768
    2.2589
    6.0602
    7.1200
    8.3094
    9.3331
    7.5529
    6.7282
    6.5122
    6.9793
    7.9874
    6.2315
    1.1841
   -1.1199
   -1.5304
   -1.3774
    1.1599
    1.4889
    1.4667
    2.3857
    1.7028
    2.5784
    3.2206
    3.6613
    5.9841
    4.7222
    5.3195
    8.7982
   10.1890
    9.3480
    7.4651
    5.1148
    2.1010
   -0.1449
   -0.3468
    2.0607
    4.8610
    5.0968
    1.9674
    0.0479
   -0.4790
   -2.8724
   -3.7386
   -2.3803
   -0.7626
   -0.1816
   -0.8206
   -1.3201
   -1.5476
   -1.3322];

%---------------------------------------------------
% Obrazek casove rady
%---------------------------------------------------
figure
plot(y)
hold on
plot(mean(y)*ones(size(y)),'g')
plot(zeros(size(y)),'k:')
title('Pozorovana rada')
legend('data','prumer','zero line')
% zjistujeme zda ma proces nenulovou stredni hodnotu, v tom pripade bychom
% proces modelovali jako ARMAX

%---------------------------------------------------
% Autokor. a parc. autokor. fce
%---------------------------------------------------
figure
subplot(2,1,1)
plotacf(y,29)
title('Autokorelacni funkce')
subplot(2,1,2)
plotpacf(y,29)
title('Parcialni autokor. fce')

% acf i pacf klesaji systematicky do konfidencnich intervalu. Bude se zrejme jednat o smiseny proces. Generujicim procesem je ARMA(1,1). Zkusime odhadnou blizke modely podle FPE kriteria.
% Ukaze se ze se skutecne jedna o ARMA(1,1).

%---------------------------------------------------
% Odhad
%---------------------------------------------------
% Odhad parametru modelu pomoci funkce ARMAX -- viz help a documentation
th=armax(y,[1 1]); % arma11

%---------------------------------------------------
% Zobrazeni vysledku
%---------------------------------------------------
% funkce PRESENT zobrazi vysledky odhadu parametru modelu, smerodatne
% odchylky parametru modelu, ztratovou funkci a Akaikeho kriterium FPE
% (final prediction error).
% Vzdy budeme volit model s parametry statisticky vyznamnymi - to bude
% jakasi pripustna mnozina modelu, vybereme ten s minimalni chybou (FPE).
%
% Vyznamnost parametru otestujeme pomoci t-testu. Podil absolutni hodnoty
% parametru a jeho smerodatne odchylky ma byt vetsi nez prislusny Studentuv
% kvantil, coz je pro velka n zhruba 2. 
% Staci tedy zjistit, je-li parametr vic nez 2x tak velky jako jeho std.
present(th) % FPE  1.18 <- nejnizsi

%---------------------------------------------------
% Jine modely
%---------------------------------------------------
% pro jistotu si odhadneme jine, blizke procesy abychom nasli nejnizsi FPE
th2=armax(y,[0 2]); % MA2
present(th2) % FPE 2.53
th3=armax(y,[1 0]); % AR1
present(th3) % FPE 2.12
th4=armax(y,[2 0]); % AR2
present(th4) % FPE 1.6
th4=armax(y,[0 1]); % MA1
present(th4) % FPE 5.41
th4=armax(y,[2 2]); % ARMA22
present(th4) % parametr prvniho zpozdeni MA casti je statisticky nevyznamny
% spravne bychom mohli zkouset i vyssi rady jako AR3, MA3, ARMA21, ARMA12,
% ARMA23, ARMA32, ...

%---------------------------------------------------
% Verifikace - predvyrobene funkce (nutno zkopirovat k sobe)
%---------------------------------------------------
% a) verifikace parametru
p_sig = par_sig(th) % help par_sig pro vice info
% b) verifikace rezidui
[sig,tests,sk]=res_sig(th,y) %help res_sig pro vice info

%---------------------------------------------------
% Stabilita
%---------------------------------------------------
% Stabilitu otestujeme pomoci funkce PZMAP, ktera pocita/kresli nuly a poly
% systemu, chceme je vsechny uvnitr jednotkove kruznice
figure
pzmap(th)


%---------------------------------------------------
% Predikce
%---------------------------------------------------
% na vypocet predikci slouzi funkce PREDICT, pro predikci modelu v theta
% formatu a pro dana data na K kroku dopredu pouzivame prikaz:
% YP = PREDICT(MODEL,DATA,K)

% K je predikcni horizont, k predikci hodnoty na "K" obdobi dopredu se
% pouziji veskera data dostupna do casu "t-K".

% Jednokrokove predikce modelu
figure
yp1=predict(th,y,1);
plot(y,'b')
hold on
plot(yp1,'r');
title('Predpoved na 1 krok dopredu')
hold off

% Dvoukrokove predikce modelu
figure
yp2=predict(th,y,2);
plot(y,'b')
hold on
plot(yp2,'r');
title('Predpoved na 2 kroky dopredu')
hold off

% Trikrokove predikce modelu
figure
yp3=predict(th,y,3);
plot(y,'b')
hold on
plot(yp3,'r');
title('Predpoved na 3 kroky dopredu')
hold off


